<?php
/**
* @version		$Id: helper.php 15198 2010-03-05 09:06:05Z ian $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
$document = &JFactory::getDocument();
require_once (JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_content'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'route.php');
require_once('modules/mod_yj_newsflash2/lib/slike.php');

class modYJNF2Helper
{
	function YJNF2getItems(&$params)
	{
		global $mainframe;

		$nitems 		= $params->get ('nitems',4);
		$ordering 		= $params->get('ordering',3);// 1 = ordering | 2 = popular | 3 = random 
		$get_items 		= $params->get('get_items',1);
		$getspecific 	= $params->get ('getspecific');
		$showcomments 	= $params->get('showcomments');	
		$chars 			= $params->get ('chars',40);
		$chars_title	= $params->get ('chars_title',10);
		$chars_title2	= $params->get ('chars_title2',10);
		$allow_tags		= $params->get ('allow_tags');
		$allow_tags 				= str_replace(" />", ">", $allow_tags);	
		/* add styles and scripts */			
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::base() . 'modules/mod_yj_newsflash2/css/stylesheet.css');

		/* prepare database */
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');
		$aid		= JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$nullDate	= $db->getNullDate();
		$date =       & JFactory::getDate();
		if(intval(JVERSION) >= 3 ){	
			$now =         $date->toSql() ; 
		}else{
			$now =         $date->toMySQL(); 
		}
		
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		// select specific items
		if(!empty($getspecific)){
		$countitems = count($getspecific);
		}
		if(!empty($getspecific) && $countitems > 1 ){
			$specificitems = implode(",", $getspecific);
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}elseif(!empty($getspecific) && $countitems == 1 ){
			$specificitems = $getspecific[0];
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}else{
			$specificitems='';
			$specific_order='NULL';
			$where .= ' AND cc.id = '.$get_items.'';
		}
		/* set items order */
		$ord = array(
			1=>'ordering',
			2=>'hits',
			3=>'RAND()',
			4=>'created ASC',
			5=>'created DESC',
			6=>$specific_order
		);
		$order = $ord[$ordering];
		/* get items */
		$sql = 	'SELECT a.*, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'. 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
				'cc.title as cattitle'.
		
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE '. $where .'' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : '').
				' AND cc.published = 1' .
				' ORDER BY '.$order .' LIMIT 0,'.$nitems.'';
		
		$db->setQuery( $sql );
		$load_items = $db->loadObjectList();
		
		
		$yjnf2_items =array();
		foreach ( $load_items as $row ) {

			$yjnf2_item = array(
					'item_date' 	=> JHTML::_('date', $row->created,JText::_('CREATEDATE')),
					'item_intro' 	=> substr(strip_tags($row->introtext,''.$allow_tags.''),0,$chars),
					'item_link' 	=> htmlspecialchars(JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug)), ENT_QUOTES, 'UTF-8'),
					'item_img' 		=> yjnf2_image($row),
					'item_title' 	=> substr(strip_tags($row->title),0,$chars_title2),
					'item_title1' 	=> substr(strip_tags($row->title),0,$chars_title),
					'item_id'	 	=> $row->id,
					'item_ctitle' 	=> htmlspecialchars($row->cattitle, ENT_QUOTES, 'UTF-8'),
					'cat_link'		=> JRoute::_(ContentHelperRoute::getCategoryRoute($row->catid))
				);
				$yjnf2_items[] = $yjnf2_item;
			}
			return $yjnf2_items;
	}
}
?>